-- name: [CS] Gwimbly
-- description: Ooo ooo ooo!
--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/blob/main/API-doc.md
]]

local E_MODEL_GWIMBLY_MODEL = smlua_model_util_get_id("gwimbly_geo")

local E_MODEL_GWIMBLY_COLOR_MODEL = smlua_model_util_get_id("gwimbly_color_geo")

local TEXT_MOD_NAME = "Gwimbly Pack"

local CAPTABLE_GWIMBLY = {
    normal = smlua_model_util_get_id("gwimblys_cap_geo")
}

local VOICETABLE_GWIMBLY = {
    [CHAR_SOUND_PANTING] = 'ough.ogg',
    [CHAR_SOUND_ATTACKED] = 'gwimblygun.ogg',
    [CHAR_SOUND_DROWNING] = 'drowning.ogg',
    [CHAR_SOUND_DYING] = 'ooh sad.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'yeah3.ogg',
    [CHAR_SOUND_HAHA] = 'yeah3.ogg',
    [CHAR_SOUND_HAHA_2] = 'oh_cool.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'ooh.ogg',
    [CHAR_SOUND_HOOHOO] = 'yeah3.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'fent.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'ooh.ogg',
    [CHAR_SOUND_ON_FIRE] = 'augh.ogg',
    [CHAR_SOUND_OOOF] = 'buzzoff.ogg',
    [CHAR_SOUND_OOOF2] = 'buzzoff.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'yeah3.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'oh_cool.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'rockon.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'fuckyou.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'rockon.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'gwimblygun.ogg',
    [CHAR_SOUND_WAH2] = 'thriving.ogg',
    [CHAR_SOUND_WHOA] = 'thriving.ogg',
    [CHAR_SOUND_YAHOO] = 'yeah3.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'yeah2.ogg', 'oh_cool.ogg', 'yeah.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'rockon.ogg','oh_cool.ogg','yeah3.ogg'},
}

if _G.charSelectExists then
    _G.charSelect.character_add("Gwimbly", {"Ooo ooo ooo!"}, "Trashcam", {r = 255, g = 185, b = 139}, E_MODEL_GWIMBLY_MODEL, CT_MARIO, get_texture_info("gwimbly"))
    _G.charSelect.character_add("Customizable Gwimbly", {"Ooo ooo ooo!"}, "Trashcam", {r = 255, g = 185, b = 139}, E_MODEL_GWIMBLY_COLOR_MODEL, CT_MARIO, get_texture_info("gwimbly"))
    _G.charSelect.character_add_caps(E_MODEL_GWIMBLY_MODEL, CAPTABLE_GWIMBLY)
    _G.charSelect.character_add_caps(E_MODEL_GWIMBLY_COLOR_MODEL, CAPTABLE_GWIMBLY)

    _G.charSelect.character_add_voice(E_MODEL_GWIMBLY_MODEL, VOICETABLE_GWIMBLY)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
    if _G.charSelect.character_get_voice(m) == VOICETABLE_GWIMBLY then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_GWIMBLY then return _G.charSelect.voice.snore(m) end
    end)

    _G.charSelect.character_add_voice(E_MODEL_GWIMBLY_COLOR_MODEL, VOICETABLE_GWIMBLY)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
    if _G.charSelect.character_get_voice(m) == VOICETABLE_GWIMBLY then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_GWIMBLY then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end